
/**
 * typed-contracts v0.3.1
 * Validation with good type inference (Flow support)
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var valueToString = function valueToString(value) {
  if (Number.isNaN(value)) return 'NaN';
  if (typeof value == 'function') return '[Function]'; // $FlowFixMe

  if (_typeof(value) == 'symbol') return value.toString();

  switch (value) {
    case Infinity:
      return Infinity.toString();

    case -Infinity:
      return (-Infinity).toString();

    case undefined:
      return 'undefined';

    case null:
      return 'null';

    default:
      return "".concat(JSON.stringify(value), " (").concat(_typeof(value), ")");
  }
};

var typesToString = function typesToString(expectedTypes) {
  return expectedTypes.slice(0, -2).concat(expectedTypes.slice(-2).join(' or ')).join(', ');
};

var ValidationError =
/*#__PURE__*/
function (_TypeError) {
  _inherits(ValidationError, _TypeError);

  _createClass(ValidationError, null, [{
    key: "of",
    value: function of(valueName, value, expectedType) {
      for (var _len = arguments.length, otherExpectedTypes = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        otherExpectedTypes[_key - 3] = arguments[_key];
      }

      return _construct(ValidationError, [valueName, value, expectedType].concat(otherExpectedTypes));
    }
  }]);

  function ValidationError(valueName, value, expectedType) {
    var _this;

    _classCallCheck(this, ValidationError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ValidationError).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "valueName", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "expectedTypes", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "value", void 0);

    _this.name = 'ValidationError';
    _this.valueName = valueName;
    _this.value = value;

    for (var _len2 = arguments.length, otherExpectedTypes = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
      otherExpectedTypes[_key2 - 3] = arguments[_key2];
    }

    _this.expectedTypes = [expectedType].concat(otherExpectedTypes);
    _this.message = "".concat(_this.valueName, " must be ").concat(typesToString(_this.expectedTypes), ", but ").concat(valueToString(value), " given");
    return _this;
  }

  return ValidationError;
}(_wrapNativeSuper(TypeError));

var createContract =
/* :: <T> */
function createContract(validate) {
  var maybe = function maybe(valueName, value) {
    return value == null ? value : validate(valueName, value);
  };

  var optional = function optional(valueName, value) {
    return value === undefined ? value : validate(valueName, value);
  };

  var contract = function contract(valueName, value) {
    return validate(valueName, value);
  };

  contract.maybe = maybe;
  contract.optional = optional;

  contract.bindName = function (valueName) {
    var named = function named(value) {
      return validate(valueName, value);
    };

    named.maybe = function (value) {
      return maybe(valueName, value);
    };

    named.optional = function (value) {
      return optional(valueName, value);
    };

    return named;
  };

  return contract;
};

var array = function array(contract) {
  return createContract(function (valueName, value) {
    if (!Array.isArray(value)) return ValidationError.of(valueName, value, 'Array');

    for (var index = 0; index < value.length; index += 1) {
      var result = contract("".concat(valueName, "[").concat(index, "]"), value[index]);
      if (result instanceof ValidationError) return result;
    }

    return value;
  });
};
var isArray = array;
var passArray = array;
var arr = array;
var isArr = array;
var passArr = array;

var boolean = createContract(function (name, value) {
  return typeof value === 'boolean' ? value : ValidationError.of(name, value, 'boolean');
});
var isBoolean = boolean;
var passBoolean = boolean;
var bool = boolean;
var isBool = boolean;
var passBool = boolean;

var literal = function literal(expected) {
  return createContract(function (valueName, value) {
    if (value === expected) return value;
    return ValidationError.of(valueName, value, JSON.stringify(expected));
  });
};
var isLiteral = literal;
var passLiteral = literal;
var lit = literal;
var isLit = literal;
var passLit = literal;

var nul = createContract(function (name, value) {
  return value === null ? value : ValidationError.of(name, value, 'null');
});
var isNull = nul;
var passNull = nul;

var number = createContract(function (name, value) {
  return typeof value === 'number' ? value : ValidationError.of(name, value, 'number');
});
var isNumber = number;
var passNumber = number;
var num = number;
var isNum = number;
var passNum = number;

var union =
/* :: <T, L: string | number | boolean> */
function union() {
  for (var _len = arguments.length, rules = new Array(_len), _key = 0; _key < _len; _key++) {
    rules[_key] = arguments[_key];
  }

  var contracts = rules.map(function (rule) {
    return typeof rule == 'function' ? rule : literal(rule);
  });

  var unionContract = function unionContract(name, value) {
    var errors = contracts.map(function (contract) {
      return contract(name, value);
    }).reduce(function (scope, error) {
      if (error instanceof ValidationError) scope.push(error);
      return scope;
    }, []);
    if (errors.length !== contracts.length) return value;
    var types = errors.reduce(function (scope, _ref) {
      var expectedTypes = _ref.expectedTypes;

      for (var i = 0; i < expectedTypes.length; i += 1) {
        scope.push(expectedTypes[i]);
      }

      return scope;
    }, []);
    return ValidationError.of.apply(void 0, [name, value].concat(_toConsumableArray(types)));
  };

  return createContract(unionContract);
};
var isUnion = union;
var passUnion = union;
var uni = union;
var isUni = union;
var passUni = union;

var always = function always(value) {
  return function () {
    return (
      /* :: ..._: $ReadOnlyArray<any> */
      value
    );
  };
};

var handler = function handler(spec) {
  var isArray = Array.isArray(spec);
  var getContract = isArray ? always(union.apply(void 0, _toConsumableArray(spec))) : function (keyName) {
    return spec[keyName];
  };
  var specKeys = isArray ? undefined : Object.keys(spec);
  return function (valueName, value) {
    if (!value || _typeof(value) !== 'object' || Array.isArray(value)) return ValidationError.of(valueName, value, 'Object');
    var keys = specKeys || Object.keys(value);

    for (var index = 0; index < keys.length; index += 1) {
      var keyName = keys[index];
      var contract = getContract(keyName);
      var currentValue = value[keyName];
      var result = contract("".concat(valueName, ".").concat(keyName), currentValue);
      if (result instanceof ValidationError) return result;
    }

    return value;
  };
};

var object = function object(spec) {
  return createContract(handler(spec));
};
var isObject = object;
var passObject = object;
var obj = object;
var isObj = object;
var passObj = object;

var objectOf = function objectOf() {
  for (var _len = arguments.length, rules = new Array(_len), _key = 0; _key < _len; _key++) {
    rules[_key] = arguments[_key];
  }

  return createContract(handler(Object.entries(rules).reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        rule = _ref2[1];

    acc[key] = typeof rule == 'function' ? rule : literal(rule);
    return acc;
  }, {})));
};
var isObjectOf = objectOf;
var passObjectOf = objectOf;
var objOf = objectOf;
var isObjOf = objectOf;
var passObjOf = objectOf;

var string = createContract(function (name, value) {
  return typeof value === 'string' ? value : ValidationError.of(name, value, 'string');
});
var isString = string;
var passString = string;
var str = string;
var isStr = string;
var passStr = string;

var undef = createContract(function (name, value) {
  return value === undefined ? value : ValidationError.of(name, value, 'void');
});
var isUndefined = undef;
var passUndefined = undef;
var isUndef = undef;
var passUndef = undef;
var isVoid = undef;
var passVoid = undef;

exports.array = array;
exports.isArray = isArray;
exports.passArray = passArray;
exports.arr = arr;
exports.isArr = isArr;
exports.passArr = passArr;
exports.boolean = boolean;
exports.isBoolean = isBoolean;
exports.passBoolean = passBoolean;
exports.bool = bool;
exports.isBool = isBool;
exports.passBool = passBool;
exports.literal = literal;
exports.isLiteral = isLiteral;
exports.passLiteral = passLiteral;
exports.lit = lit;
exports.isLit = isLit;
exports.passLit = passLit;
exports.nul = nul;
exports.isNull = isNull;
exports.passNull = passNull;
exports.number = number;
exports.isNumber = isNumber;
exports.passNumber = passNumber;
exports.num = num;
exports.isNum = isNum;
exports.passNum = passNum;
exports.object = object;
exports.isObject = isObject;
exports.passObject = passObject;
exports.obj = obj;
exports.isObj = isObj;
exports.passObj = passObj;
exports.objectOf = objectOf;
exports.isObjectOf = isObjectOf;
exports.passObjectOf = passObjectOf;
exports.objOf = objOf;
exports.isObjOf = isObjOf;
exports.passObjOf = passObjOf;
exports.string = string;
exports.isString = isString;
exports.passString = passString;
exports.str = str;
exports.isStr = isStr;
exports.passStr = passStr;
exports.union = union;
exports.isUnion = isUnion;
exports.passUnion = passUnion;
exports.uni = uni;
exports.isUni = isUni;
exports.passUni = passUni;
exports.undef = undef;
exports.isUndefined = isUndefined;
exports.passUndefined = passUndefined;
exports.isUndef = isUndef;
exports.passUndef = passUndef;
exports.isVoid = isVoid;
exports.passVoid = passVoid;
exports.createContract = createContract;
exports.ValidationError = ValidationError;
